"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const metadata_1 = require("../../metadata");
const injectable_decorator_1 = require("../services/injectable.decorator");
function Controller(meta) {
    let controllerMeta = typeof meta === 'string' ? { path: meta } : (meta || {});
    return function (controller) {
        Reflect.defineMetadata(metadata_1.ControllerMetadataSym, controllerMeta, controller.prototype);
        let routes = Reflect.getOwnMetadata(metadata_1.ControllerRoutesSym, controller.prototype) || [];
        Reflect.defineMetadata(metadata_1.ControllerRoutesSym, routes, controller.prototype);
        injectable_decorator_1.Injectable()(controller);
    };
}
exports.Controller = Controller;
//# sourceMappingURL=controller.decorator.js.map