import { Injector } from '../../core/injector';
export declare type Charset = 'utf8' | 'utf8mb4';
export declare type DatabaseMetadataT = {
    name: string;
    user: string;
    password: string;
    host: string | {
        domain: string;
        port?: number;
    };
    dialect?: string;
    charset?: Charset;
    pool?: {
        min?: number;
        max?: number;
        idle?: number;
    };
};
export declare class DatabaseMetadata implements DatabaseMetadataT {
    private _meta;
    constructor(_meta: DatabaseMetadataT, injector: Injector);
    readonly name: string;
    readonly user: string;
    readonly password: string;
    private _domain;
    private _port;
    readonly host: {
        domain: string;
        port: number;
    };
    readonly dialect: string;
    readonly charset: Charset;
    private _minPool;
    private _maxPool;
    private _idlePool;
    readonly pool: {
        min: number;
        max: number;
        idle: number;
    };
}
