import { StaticModelT, ModelT, PkType } from '../../core/model';
import { Injector } from '../../core/injector';
import { DatabaseMetadataT, DatabaseMetadata } from './database';
export declare type OrmMetadataT = {
    enabled?: boolean;
    db?: DatabaseMetadataT;
    recreate?: boolean;
    models?: StaticModelT<ModelT<PkType>>[];
};
export declare class OrmMetadata implements OrmMetadataT {
    private _meta;
    constructor(_meta: OrmMetadataT, injector: Injector);
    readonly enabled: boolean;
    readonly models: StaticModelT<ModelT<string | number>>[];
    readonly recreate: boolean;
    private _db;
    readonly db: DatabaseMetadata;
}
