"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const injector_1 = require("../../core/injector");
const injectable_decorator_1 = require("../../decorators/services/injectable.decorator");
const database_1 = require("./database");
let OrmMetadata = OrmMetadata_1 = class OrmMetadata {
    constructor(_meta, injector) {
        this._meta = _meta;
        if (injector)
            injector.provide({ provide: OrmMetadata_1, useValue: this });
        if (this._meta.db)
            this._db = new database_1.DatabaseMetadata(this._meta.db, injector);
        else if (injector)
            injector.provide({ provide: database_1.DatabaseMetadata, useValue: null });
    }
    get enabled() {
        if (typeof this._meta.enabled === 'undefined')
            return true;
        return !!this._meta.enabled;
    }
    get models() {
        return this._meta.models || [];
    }
    get recreate() {
        return !!this._meta.recreate;
    }
    get db() {
        return this._db;
    }
};
OrmMetadata = OrmMetadata_1 = __decorate([
    injectable_decorator_1.Injectable(),
    __metadata("design:paramtypes", [Object, injector_1.Injector])
], OrmMetadata);
exports.OrmMetadata = OrmMetadata;
var OrmMetadata_1;
//# sourceMappingURL=orm.js.map