/// <reference types="express" />
import { Handler } from 'express';
import { PolicyDescriptor } from '../../core/policy';
import { CtorT } from '../../core/ctor';
import { ControllerT } from '../../core/controller';
import { Injector } from '../../core/injector';
export declare type RouterMetadataT = {
    path?: string;
    middleware?: Handler[];
    policies?: PolicyDescriptor[];
    controllers?: CtorT<ControllerT>[];
};
export declare class RouterMetadata implements RouterMetadataT {
    private _meta;
    constructor(_meta: RouterMetadataT, injector: Injector);
    readonly path: string;
    readonly middleware: Handler[];
    readonly policies: PolicyDescriptor[];
    readonly controllers: CtorT<ControllerT>[];
}
