"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const injector_1 = require("../../core/injector");
const injectable_decorator_1 = require("../../decorators/services/injectable.decorator");
const orm_1 = require("./orm");
const ssl_1 = require("./ssl");
const router_1 = require("./router");
const views_1 = require("./views");
const jwt_1 = require("./jwt");
let ServerMetadata = ServerMetadata_1 = class ServerMetadata {
    constructor(_meta, injector) {
        this._meta = _meta;
        this._router = null;
        this._views = null;
        this._jwt = null;
        if (injector)
            injector.provide({ provide: ServerMetadata_1, useValue: this });
        this._ssl = new ssl_1.SSLMetadata(this._meta.ssl || {}, injector);
        this._orm = new orm_1.OrmMetadata(this._meta.orm || {}, injector);
        if (this._meta.router)
            this._router = new router_1.RouterMetadata(this._meta.router || {}, injector);
        else if (injector)
            injector.provide({ provide: router_1.RouterMetadata, useValue: this._router });
        if (this._meta.views)
            this._views = new views_1.ViewsMetadata(this._meta.views || {}, injector);
        else if (injector)
            injector.provide({ provide: views_1.ViewsMetadata, useValue: this._views });
        if (this._meta.jwt)
            this._jwt = new jwt_1.JwtMetadata(this._meta.jwt, injector);
        else if (injector)
            injector.provide({ provide: jwt_1.JwtMetadata, useValue: this._jwt });
    }
    get name() {
        return this._meta.name;
    }
    get port() {
        return this._meta.port || 80;
    }
    get allowCrossOrigin() {
        return this._meta.allowCrossOrigin || false;
    }
    get ssl() {
        return this._ssl;
    }
    get router() {
        return this._router;
    }
    get views() {
        return this._views;
    }
    get orm() {
        return this._orm;
    }
    get services() {
        return this._meta.services || [];
    }
    get inject() {
        return this._meta.inject || [];
    }
    get jwt() {
        return this._jwt;
    }
    get logLevel() {
        return this._meta.logLevel || 'warn';
    }
    get debugBreakpoint() {
        return this._meta.debugBreakpoint || (() => void (0));
    }
};
ServerMetadata = ServerMetadata_1 = __decorate([
    injectable_decorator_1.Injectable(),
    __metadata("design:paramtypes", [Object, injector_1.Injector])
], ServerMetadata);
exports.ServerMetadata = ServerMetadata;
var ServerMetadata_1;
//# sourceMappingURL=server.js.map