import { Request, Response } from 'express';
import { JwtMetadata } from '../metadata/server/jwt';
import { LoggerCore } from '../services/logger-core';
import { Logger } from '../services/logger';
export declare class JwtBasePolicy {
    private jwtMeta;
    credentialsRequired: boolean;
    constructor(jwtMeta: JwtMetadata, loggerCore: LoggerCore, credentialsRequired: boolean);
    protected readonly logger: Logger;
    readonly property: string | undefined;
    private jwtHandler;
    handle(req: Request, res: Response): Promise<any>;
    protected getToken(req: Request): string | null;
    private getJwt(req, res);
    protected fromJson(json: any): Promise<any>;
}
