/// <reference types="express" />
import { Application as ExpressApp } from 'express';
import { Injector } from '../core/injector';
import { ServerMetadataT, ServerMetadata } from '../metadata/server/server';
export declare class Server {
    constructor(meta: ServerMetadataT);
    private _meta;
    readonly meta: ServerMetadata;
    private _loggerCore;
    private readonly logger;
    private _app;
    readonly app: ExpressApp;
    private _injector;
    readonly injector: Injector;
    init(): Promise<void>;
    initImpl(): Promise<void>;
    private initPromise;
    startTime: Date | null;
    errorCode: number;
    private onSIGINT();
    shutdown(): Promise<void>;
    createExpressApp(): void;
    private ormReflector;
    reflectOrm(): Promise<void>;
    private serviceReflector;
    private startServices();
    private stopServices();
    private routerReflector;
    private reflectRoutes();
    private webServer;
    private listen();
    private stopListening();
    private onError(error);
    private onListening();
}
