import { CtorT } from '../core/ctor';
import { ServiceT } from '../core/service';
import { Injector } from '../core/injector';
import { ServerMetadata } from '../metadata/server/server';
import { Logger } from '../services/logger';
export declare class ServiceReflector {
    private injector;
    private serverMeta;
    private logger;
    constructor(injector: Injector, serverMeta: ServerMetadata, logger: Logger);
    startServices(): Promise<void>;
    private _startedServices;
    reflectServices(services: CtorT<ServiceT>[]): Promise<boolean>;
    reflectService(serviceFn: CtorT<ServiceT>): Promise<boolean>;
    shutdownServices(): Promise<boolean>;
    shutdownServicesImpl(): Promise<boolean>;
    shutdownService(service: ServiceT): Promise<boolean>;
}
