"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const sinonChai = require("sinon-chai");
chai_1.use(sinonChai);
const inheritance_hierarchy_1 = require("../inheritance-hierarchy");
describe('util/inhertitanceHierarchy', () => {
    it('should return an array with all OOP ancestors for a class', () => {
        class A {
        }
        class B extends A {
        }
        class C extends B {
        }
        class D extends C {
        }
        chai_1.expect(inheritance_hierarchy_1.inhertitanceHierarchy(A).splice(1)).to.be.deep.eq([A]);
        chai_1.expect(inheritance_hierarchy_1.inhertitanceHierarchy(B).splice(1)).to.be.deep.eq([A, B]);
        chai_1.expect(inheritance_hierarchy_1.inhertitanceHierarchy(C).splice(1)).to.be.deep.eq([A, B, C]);
        chai_1.expect(inheritance_hierarchy_1.inhertitanceHierarchy(D).splice(1)).to.be.deep.eq([A, B, C, D]);
    });
});
//# sourceMappingURL=inheritance-hierarchy.spec.js.map