"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const sinon = require("sinon");
const direct_logger_1 = require("../../util/direct-logger");
function stubDirectLogger() {
    let stubbed = {};
    beforeEach(() => {
        stubbed.log = sinon.stub(direct_logger_1.directLogger, 'log');
        stubbed.info = sinon.stub(direct_logger_1.directLogger, 'info');
        stubbed.warn = sinon.stub(direct_logger_1.directLogger, 'warn');
        stubbed.error = sinon.stub(direct_logger_1.directLogger, 'error');
        stubbed.trace = sinon.stub(direct_logger_1.directLogger, 'trace');
    });
    afterEach(() => {
        stubbed.log.restore();
        stubbed.info.restore();
        stubbed.warn.restore();
        stubbed.error.restore();
        stubbed.trace.restore();
    });
    return stubbed;
}
exports.stubDirectLogger = stubDirectLogger;
//# sourceMappingURL=stub-direct-logger.js.map