"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function wrapCallback(promiseFn) {
    return function (...allArgs) {
        let done = allArgs[allArgs.length - 1];
        let args = allArgs.splice(0, allArgs.length - 1);
        promiseFn(...args)
            .catch(err => done(err, undefined))
            .then(result => done(undefined, result));
    };
}
exports.wrapCallback = wrapCallback;
//# sourceMappingURL=wrap-callback.js.map